// -*-C++-*-
/*!
 * @file  BetaRnaSVC_impl.cpp
 * @brief Service implementation code of BetaRna.idl
 * @date  $Date: 2007/01/11 07:44:39 $
 *
 * $Id: cxx_svc_impl.py,v 1.3 2007/01/11 07:44:39 n-ando Exp $
 */
#include	<unistd.h>
#include	<stdio.h>
#include	<stdlib.h>
#include "BetaRnaSVC_impl.h"

/*
 * Example implementational code for IDL interface BetaRna
 */
BetaRnaSVC_impl::BetaRnaSVC_impl()
{
  // Please add extra constructor code here.
}


BetaRnaSVC_impl::~BetaRnaSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
CORBA::Short BetaRnaSVC_impl::Init(const char* sRnaDir, CORBA::Short iInputCh)
{
  if( m_cBD.SetPath( (char*)sRnaDir ) )
    fprintf( stdout, "Set RnaDir -> %s.\n", sRnaDir );
  else
    return 1;

  if( m_cBD.SetChannel( (int)iInputCh ) )
    fprintf( stdout, "Set Input -> %d.\n", (int)iInputCh );
  else
    return 2;

  return 0;
}

CORBA::Short BetaRnaSVC_impl::Exec(CORBA::Short            iTalkerID,
                                   const BetaRna::DArray&  aInputData, 
                                   CORBA::Short&           iResultID,
                                   CORBA::Double&          dTrusty)
{
  int      i, iCount, iRet;
  double   dRet;
  double*  pData;

  iCount = aInputData.length();
  pData = (double*)malloc( sizeof( double ) * iCount );
  if( ! pData ) {
    fprintf( stdout, "Error in malloc(%d).\n", sizeof( double ) * iCount );
    return 1;
  }
  for( i = 0; i < iCount; i++ )
    pData[i] = aInputData[i];

  if( m_cBD.DriveRna( (int)iTalkerID, pData, &iRet, &dRet ) ) {
    iResultID = iRet;
    dTrusty = dRet;
    iRet = 0;
  }
  else {
    iRet = 2;
  }
  free( (void*)pData );
  return iRet;
}



// End of example implementational code



