/*
  @file   CBetaDriver.h
  @brief  wK_CuBetaRNA ̃hCoNX
  @author AdIn Research,Inc
  @date   2007/02/22
*/

#ifndef __C_BETA_DRIVER_H__
#define __C_BETA_DRIVER_H__

#include <sys/param.h>

#define BD_PARAM_NAME    "rs1.ila"
#define BD_STUDY_NAME    "rs1.bra"
#define BD_INPUT_NAME    "rs1.brs"
#define BD_EXPAND_SIZE   (16)
#define BD_OUTPUT_MAX    (16)


// ̓f[^obt@\
struct tOneDatas
{
  int      iOutputID;
  double*  pdData;
};



// RNA bp[NX
class CBetaDriver
{
private:
  char  m_sParamPath[PATH_MAX];
  char  m_sStudyPath[PATH_MAX];
  char  m_sInputPath[PATH_MAX];
  bool  m_bInitPath;
  bool  m_bInitChannel;
  bool  m_bStudyOnly;
  int   m_iOutputMax;  // wKőo͒l
  int   m_iInputCh;    // ̓`l
  int   m_iPrintMode;  // PMODE_NORMAL | PMODE_VERBOSE | PMODE_SIMPLE ̑gݍ킹 (ʏ́APMODE_NORMALł悢)

  // AwKpobt@
  int         m_iBufSize;
  int         m_iBufUse;
  tOneDatas*  m_pBuf;

  bool expandBuf( void );
  void clearBuf( void );

  bool outDataFile(int iInput, tOneDatas* pInput );

  bool study( void );
  bool detect( int* piRet, double* pdTrust );

public:
  CBetaDriver( void );
  ~CBetaDriver( void );

  // ֐
  bool SetPath( const char* sDir );
  bool SetChannel( int iCh ); // SetChanneĺAxݒ肵AύX͕s

  // PwKE_	
  bool DriveRna( int iOutputID, const double* pdData, int* piRet, double* pdTrust );

  // wKf[^𒙂߂
  bool AddData( int iOutputID, const double* pdData );

  // ߂wKf[^ꊇwK
  bool DriveRna( void );

};

#endif // __C_BETA_DRIVER_H__
