/*******************************************************************************
 *      (C)Copyright       AdIn Reserch, Inc.                 1991-1993.       *
 *******************************************************************************
 *******************************************************************************
 *
 *  File name    : mmi00fnc.h
 *
 *  Note         : Header file for B-RNA graphic mmi
 *                     - define external functions -
 *
 * $Revision: 2.26 $
 * $Author: fujimaki $
 * $Date: 1999/11/05 03:04:05 $
 * $Locker:  $
 *
 ******************************************************************************/
 
#if !defined(_MMI00FNC_H_)
#   define _MMI00FNC_H_

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/*----- Callback prototype macro ---------------------------------------------*/
#define RmPROTOTYPE_CB(f)  PROTOTYPE(f, (Widget, caddr_t, caddr_t))

/*============================================================================*/
/*===== Define internal functions ============================================*/
/*============================================================================*/

/*----- Error Function and Macro ---------------------------------------------*/
extern void PROTOTYPE( _RMError, (Widget, Ferr, char *, int));
#define RMError(err)  _RMError((Widget)NULL, err, __FILE__, __LINE__)

/*----- Get root information -------------------------------------------------*/
extern void         PROTOTYPE( rmSetFixedFontList,  (Widget));
extern int          PROTOTYPE( rmSetRNAApatWidth,   (int));
extern char        *PROTOTYPE( rmGetRNAFileMessage, (int));
extern Pixel        PROTOTYPE( rmGetRNAColorPixel,  (int));
extern Widget       PROTOTYPE( rmGetTopShellWidgetID,   (void));
extern Widget       PROTOTYPE( rmGetTopManagerWidgetID, (void));
extern XtAppContext PROTOTYPE( RMGetAppContext,     (void));
extern Display     *PROTOTYPE( RMGetDefaultDisplay, (void));
extern void         PROTOTYPE( RMGetRootWindowSize,
                               (unsigned int *,unsigned int *));

/*----- Get ID from table position -------------------------------------------*/
extern Ferr PROTOTYPE( rmGetPatID,  (RmGraphInf *, RmIdInf *));
extern Ferr PROTOTYPE( rmGetASenID, (RmGraphInf *, RmIdInf *));
extern Ferr PROTOTYPE( rmGetDSenID, (RmGraphInf *, RmIdInf *));
extern Ferr PROTOTYPE( rmGetAPatID, (RmGraphInf *, RmIdInf *));
extern Ferr PROTOTYPE( rmGetDPatID, (RmGraphInf *, RmIdInf *));
extern Ferr PROTOTYPE( rmGetIdInfo, (RCAT, RmGraphInf *, RmIdInf *));

extern Ferr PROTOTYPE( rmGetNormMinMaxNT, (RID, double *, RANA *));
extern Ferr PROTOTYPE( rmGetNormMinMax, (RID, RID, double *, RANA *));
extern Ferr PROTOTYPE( rmGetRanaSysMax, (RID, RANA *));

extern RNUM PROTOTYPE ( rmNofEdittingSS, (RID));
extern RNUM PROTOTYPE ( rmNofEdittingPG, (RID));
extern RNUM PROTOTYPE ( rmNofEdittingPT, (RID));
extern Ferr PROTOTYPE ( rmEntryPGrpMemberSS, (RID, RNUM *));
extern Ferr PROTOTYPE ( rmEntryPGrpMemberPT, (RID, RNUM *));

/*----- Environment operations -----------------------------------------------*/
extern int          PROTOTYPE( rmSetTableHeight,      (int));
extern int          PROTOTYPE( rmSetTableAwidth,      (int));
extern int          PROTOTYPE( rmSetTableDwidth,      (int));
extern RmPtDispType PROTOTYPE( rmSetPatDispType,      (RmPtDispType));
extern RmBool       PROTOTYPE( rmSetWeightOn,         (RmBool));
extern RmBool       PROTOTYPE( rmSetDupNameCheck,     (RmBool));
extern RmBool       PROTOTYPE( rmSetDelRuleMessage,   (RmBool));
extern RmBool       PROTOTYPE( rmSetDelDataMessage,   (RmBool));
extern char        *PROTOTYPE( rmSetDataFilePath,     (char *));
extern char        *PROTOTYPE( rmSetLearnParamFile,   (char *));
extern RmBool       PROTOTYPE( rmSetSameGroupEditMode,(RmBool));
extern Ferr         PROTOTYPE( RMInitConfig,          (void));
extern RmBool       PROTOTYPE( rmSetNtblEditting,     (RmBool));
extern RmBool       PROTOTYPE( rmSetNtblAffectData,   (RmBool));
extern void RmPROTOTYPE_CB( rmSetNtblAffectDataCB );

/*----- Table information operations -----------------------------------------*/
extern Ferr PROTOTYPE( RMCreateTableInfo, (RmWindowType, RID, RmTableInf **));
extern Ferr PROTOTYPE( RMDeleteTableInfo, (RmTableInf *));
extern Ferr PROTOTYPE( RMInitTableInfo,   (void));
extern void PROTOTYPE( RMGetTopTableInfo, (RmTableInf **));
extern void PROTOTYPE( RMGetNextTableInfo,(RmTableInf **));
extern void RmPROTOTYPE_CB( rmDeleteTableInfoCB );

/*----- Display pattern information operations -------------------------------*/
extern Ferr PROTOTYPE( RMResetPtOrder,    (RID, RNUM, RmPtOrder *));
extern Ferr PROTOTYPE( RMAgSortPtOrder,   (RID, RNUM, RmPtOrder *));
extern Ferr PROTOTYPE( RMDeleteAnOrder,   (RID, RNUM *, RmPtOrder **));
extern Ferr PROTOTYPE( RMAppendAnOrder,   (RID, RNUM *, RmPtOrder **));
extern Ferr PROTOTYPE( RMUpdatePtOrderPT, (RID, RNUM *, RmPtOrder **));
extern Ferr PROTOTYPE( RMUpdatePtOrderPS, (RNUM, RmPtOrder *));

/*----- X public functions ---------------------------------------------------*/
extern void    PROTOTYPE( rMReverseSensitive, (Widget));
extern void    PROTOTYPE( rMReverseColor,     (Widget));
extern void    PROTOTYPE( rMReverseVisible,   (Widget));
extern void    PROTOTYPE( rMDrawString,       (Widget, char *));
extern void    PROTOTYPE( rMDrawRealValue,    (Widget, double, unsigned char));
extern void    PROTOTYPE( rMDrawIntValue,     (Widget, int));
extern void    PROTOTYPE( rMDrawUlongValue,   (Widget, unsigned long));
extern void    PROTOTYPE( rMAdjustPosition,   (Widget, RmBool));
extern Pixel   PROTOTYPE( rMGetColorPixel,    (Widget, char *, char));
extern caddr_t PROTOTYPE( rMSetUserData,      (Widget, caddr_t));
extern caddr_t PROTOTYPE( rMGetUserData,      (Widget));
extern long    PROTOTYPE( rMLabelGetLong,     (Widget));
extern double  PROTOTYPE( rMLabelGetDouble,   (Widget));
extern char   *PROTOTYPE( rMLabelGetString,   (Widget));
extern long    PROTOTYPE( rMTextGetLong,      (Widget));
extern double  PROTOTYPE( rMTextGetDouble,    (Widget));
#define                   rMTextGetString(w)  XmTextGetString(w)

/*----- X public CB functions ------------------------------------------------*/
extern void RmPROTOTYPE_CB( rMFreeCB );
extern void RmPROTOTYPE_CB( rMManageDialogCB );
extern void RmPROTOTYPE_CB( rMUnmanageDialogCB );
extern void RmPROTOTYPE_CB( rMPopupWidgetCB );
extern void RmPROTOTYPE_CB( rMPopdownWidgetCB );
extern void RmPROTOTYPE_CB( rMDestroyWidgetCB );
extern void RmPROTOTYPE_CB( rMReverseSensitiveCB );
extern void RmPROTOTYPE_CB( rMReverseColorCB );
extern void RmPROTOTYPE_CB( rMReverseVisibleCB );

/*----- Public functions -----------------------------------------------------*/
extern int  PROTOTYPE( rMIsInteger,    (char *));
extern int  PROTOTYPE( rMIsReal,       (char *));
extern int  PROTOTYPE( rMRealToString, (double, unsigned char, char *));
extern int  PROTOTYPE( rMIsExistFile,  (char *));

/*----- Create widget set ----------------------------------------------------*/
extern Widget PROTOTYPE( rMCreateNameSet,
                (Widget, char *, WidgetClass, WidgetClass, Widget *, Widget *));
extern Widget PROTOTYPE( rMCreateValueSet,
                (Widget, char *, WidgetClass, Widget *));
extern Widget PROTOTYPE( rMCreateValueNameSet,
                (Widget, char *, WidgetClass, Widget *));
extern Widget PROTOTYPE( rMCreateIdNameSet,
                (Widget, char *, WidgetClass, Widget *));
extern Widget PROTOTYPE( rMCreateItemSet,
                (Widget, char *, WidgetClass, int, char **, Widget *));
extern Widget PROTOTYPE( rMCreateLimitSet,
                (Widget, char *, WidgetClass, Widget *));
extern Widget PROTOTYPE( rMCreateModeSet,
                (Widget, char *, int, int, char **, Widget *));
extern Widget PROTOTYPE( rMCreateButtonSet,
                (Widget, char *, int, char **, Widget *));
extern Widget PROTOTYPE( rMCreateCommandSet,
                (Widget, char *, char **, Widget *));
extern Widget PROTOTYPE( rMCreateScrollWinSet,
                (Widget, int, int));
extern Widget PROTOTYPE( rMCreateSeparatorG,
                (Widget, int, int, int));

/*----- Create public DialogBox ----------------------------------------------*/
extern Widget PROTOTYPE( rMCreateMessageBox,
                (Widget, char *, RmMessage, RmAnswer, RmButton, int, int));
extern Widget PROTOTYPE( rMCreatePromptBox,
                (Widget, char *, char *, int, int));

/*----- Main menu CB and File I/O CB -----------------------------------------*/
extern Ferr   PROTOTYPE( rmPrintSyntaxError, (Ferr));
extern Widget PROTOTYPE( rmCreateFSelectionBox, (int, int));

/*----- Editor's functions -pub3----------------------------------------------*/
extern Ferr PROTOTYPE( rmDrawDataLabelS,    (Widget, RCAT, RID *, RNUM));
extern Ferr PROTOTYPE( rmDrawDataLabel,     (Widget, RCAT, RID *, RNUM));
extern Ferr PROTOTYPE( rmSetDataLabel,      (Widget, RCAT, RID *, RNUM));
extern Ferr PROTOTYPE( rmSetIDandDrawLabel, (Widget, RCAT, RID *, RNUM));
extern Ferr PROTOTYPE( rmGetTableWindowSBar, (RCAT, RmTableInf *, Widget *));
extern Ferr PROTOTYPE( rmGetTableWindowChild,
                        (RCAT, RmGraphInf *, Widget *, Widget *, Widget *));
extern void RmPROTOTYPE_CB( rmCheckDoubleNameCB );
extern void RmPROTOTYPE_CB( rmEditAnaIncCB );
extern void RmPROTOTYPE_CB( rmEditAnaDecCB );
extern void RmPROTOTYPE_CB( rmEditDigIncCB );
extern void RmPROTOTYPE_CB( rmEditDigDecCB );
extern void RmPROTOTYPE_CB( rmEditPatIncCB );
extern void RmPROTOTYPE_CB( rmEditPatDecCB );

/*----- Editor's functions -pub4----------------------------------------------*/
extern RmBool PROTOTYPE( rmIsNeedCheckText, (int, Widget, double *));
extern void   PROTOTYPE( rmAddTextCallbacks,
                           (Widget, void RmPROTOTYPE_CB((*)), caddr_t));
extern void   PROTOTYPE( rmAddScaleCallbacks,
                           (Widget, void RmPROTOTYPE_CB((*)), caddr_t));
extern Widget PROTOTYPE( rmCreateDigitalSet,   (Widget, char *, Widget *));
extern Widget PROTOTYPE( rmCreateWeightSet,    (Widget, char *, Widget *));
extern Widget PROTOTYPE( rmCreateNormLimitSet, (Widget, char *, Widget *,
                                void RmPROTOTYPE_CB((*)),
                                void RmPROTOTYPE_CB((*)), caddr_t));
extern Widget PROTOTYPE( rmCreateNormSwSet,    (Widget, Widget *));
extern Widget PROTOTYPE( rmCreateEditorShell,
                        (RCAT, Widget, char *, char *, RmTableInf *));

extern void   PROTOTYPE( rmDelManagerShell, (Widget, RmBool));
extern void RmPROTOTYPE_CB( rmDelManagerShellCB );
extern void RmPROTOTYPE_CB( rmDelManagerPopshellCB );

/*----- create selection box -------------------------------------------------*/
extern void RmPROTOTYPE_CB( rmDisplaySsetInfoCB );
extern void RmPROTOTYPE_CB( rmDisplayPtblInfoCB );
extern void RmPROTOTYPE_CB( rmDisplayPgrpInfoCB );
extern void RmPROTOTYPE_CB( rmDisplayNormInfoCB );
extern void RmPROTOTYPE_CB( rmDisplayRuleInfoCB );
extern Ferr   PROTOTYPE( rmGetNofSelectSS, (RNUM, RNUM, RNUM *));
extern Ferr   PROTOTYPE( rmGetNofSelectPT, (RNUM, RNUM, RNUM *));
extern Ferr   PROTOTYPE( rmGetNofSelectPG, (RmBool, RNUM *));
extern Ferr   PROTOTYPE( rmGetSelectedAnItem, (Widget, RID *));
extern Ferr   PROTOTYPE( rmGetSelectedItems,  (Widget, RID **, RNUM *));
extern Ferr   PROTOTYPE( rmSetSelectedItems,  (Widget, RID *, RNUM));
extern Ferr   PROTOTYPE( rmSetUnselectItems,  (Widget, RID *, RNUM));
extern Widget PROTOTYPE( rmCreateNSelectSSwindow,
                            (Widget, int, int, RmBool, RNUM, RNUM, Widget *));
extern Widget PROTOTYPE( rmCreateNSelectPTwindow,
                            (Widget, int, int, RmBool, RNUM, RNUM, Widget *));
extern Widget PROTOTYPE( rmCreateNSelectPGwindow,
                            (Widget, int, int, RmBool, RmBool, Widget *));
extern Widget PROTOTYPE( rmCreateNewPGwindow, (Widget, int, int, Widget *));
extern Widget PROTOTYPE( rmCreateNewPTwindow, (Widget, int, int, Widget *));
extern Widget PROTOTYPE( rmCreateNewSSwindow, (Widget, int, int, Widget *));
extern Widget PROTOTYPE( rmSelectNormTblWindow,
                            (Widget, int, int, RmBool, Widget *));
extern Widget PROTOTYPE( rmSelectRuleTblWindow,
                            (Widget, int, int, RmBool, Widget *));
extern Widget PROTOTYPE( rmCreateInfPopupShell, (Widget, char *));

/*----- Setup / display size -------------------------------------------------*/
extern Widget PROTOTYPE( rmCreateTblWinSetupDialog,
                                 (Widget, int, int, Widget *));
extern void   PROTOTYPE( rmGetDispSizeSetValues,
                                 (Widget, RmDispSize *));
extern Widget PROTOTYPE( rmCreateDispSizeSet,
                                 (Widget, RmBool, RmBool, RmBool));
extern void   PROTOTYPE( rmGetDispSize, (RmDispSize *));
extern void   PROTOTYPE( rmSetDispSize, (RmDispSize *));

/*----- Create table window --------------------------------------------------*/
extern Ferr PROTOTYPE( rmCreateTableMenuBar, (Widget, RmTableInf *));
extern Ferr PROTOTYPE( rmCreateSensorArea,   (Widget, RmTableInf *));
extern Ferr PROTOTYPE( rmCreateSsetWindow,  (Widget,       RID, RmTableInf **));
extern Ferr PROTOTYPE( rmCreateTableWindow, (RmWindowType, RID, RmTableInf **));
extern Ferr PROTOTYPE( rmDisplayTableWindow, (RmTableInf *, RmBool));
extern void RmPROTOTYPE_CB( RMEditTableWindowCB );

/*----- Draw table window ----------------------------------------------------*/
extern Ferr PROTOTYPE( rmDrawAnalogueSensor,  (RmGraphInf *));
extern Ferr PROTOTYPE( rmDrawDigitalSensor,   (RmGraphInf *));
extern Ferr PROTOTYPE( rmDrawAnaloguePattern, (RmGraphInf *));
extern Ferr PROTOTYPE( rmDrawDigitalPattern,  (RmGraphInf *));
extern Ferr PROTOTYPE( rmDrawPatternName,     (RmGraphInf *));
extern Ferr PROTOTYPE( rmDrawAnalogueSet,     (RmTableInf *));
extern Ferr PROTOTYPE( rmDrawDigitalSet,      (RmTableInf *));
extern Ferr PROTOTYPE( rmDrawSensorSetName,   (RmGraphInf *));
extern Ferr PROTOTYPE( RMDrawGraphArea,       (RmTableInf *, RmDrawType));

/*----- Clear table window ---------------------------------------------------*/
extern void PROTOTYPE( rmClearLabelClassWidget, (Widget));
extern void PROTOTYPE( rmClearScale,            (Widget));
extern void PROTOTYPE( rmClearDrawGraph,        (Widget, Boolean));
extern Ferr PROTOTYPE( RMClearTableWindow,      (RmTableInf *, RmDrawType));

/*----- Draw Drawable --------------------------------------------------------*/
extern void PROTOTYPE( rmDrawColorMfGraph,
                                 (Widget, RMF *, RANA *, RANA, RmBool, Pixel));
extern void PROTOTYPE( rmDrawMemshipGraph,
                                 (Widget, RMF *, RANA *, RANA, RmBool));
extern void PROTOTYPE( rmDrawRectangleGraph,
                                 (Widget, double, RmBool, RmBool));
extern void PROTOTYPE( rmDrawVerLineGraph,
                                 (Widget, RANA, RANA *, Pixel));
extern void PROTOTYPE( rmDrawHorLineGraph,
                                 (Widget, RANA, RANA *, Pixel));

/*----- ScrollBar ------------------------------------------------------------*/
extern Ferr PROTOTYPE( rmModifyScrollBar, (RmTableInf *, RCAT));

/*----- Get local work area pointer ------------------------------------------*/
extern char   *PROTOTYPE( rmGetCharWorkArea,   (int));
extern RID    *PROTOTYPE( rmGetRIDWorkArea,    (RNUM));
extern RMD    *PROTOTYPE( rmGetRMDWorkArea,    (RNUM));
extern RANA   *PROTOTYPE( rmGetRANAWorkArea,   (RNUM));
extern double *PROTOTYPE( rmGetDoubleWorkArea, (RNUM));

/*============================================================================*/
/*===== Define macro =========================================================*/
/*============================================================================*/

/*----- String <-> XmString --------------------------------------------------*/
#if RmXMVERSION < 3
# if defined(OPENWARE)
#    define rMGetXstring(s)\
              (XmjpCreateConcatWords((s), XmjpDEFAULT_CHARSET_ARRAY))
#    define rMGetCstring(s,c)\
              (XmjpGetLtoRWords((s), XmjpDEFAULT_CHARSET_ARRAY, (c)))
# else
#    define rMGetXstring(s)\
              (XmStringCreate((s), XmSTRING_DEFAULT_CHARSET))
#    define rMGetCstring(s,c)\
              (XmStringGetLtoR((s), XmSTRING_DEFAULT_CHARSET, (c)))
# endif  /*OPENWARE*/
#else   /*RmXMVERSION*/
#   define rMGetXstring(s)\
              (XmStringCreate((s), XmFONTLIST_DEFAULT_TAG))
#   define rMGetCstring(s,c)\
              (XmStringGetLtoR((s), XmFONTLIST_DEFAULT_TAG, (c)))
#endif  /*RmXMVERSION*/

/*----- Memory operation -----------------------------------------------------*/
#define rMAreaAlloc(t,n)    ((t *)calloc((n), sizeof(t)))
#define rMAreaFree(a)       (free((char *)(a)))
#define rMAreaCopy(d,s,t,n) (memcpy((char *)(d),(char *)(s),(sizeof(t)*(n))))
#define rMAreaClear(a,t,n)  (memset((char *)(a), 0,(sizeof(t)*(n))))

/*---- Convert value (get new value) -----------------------------------------*/
#define rMConvert(old, omi, omx, nmi, nmx) \
                   (((double)old - (double)omi) \
                  * ((double)nmx - (double)nmi) \
                  / ((double)omx - (double)omi) + (double)nmi)

/*----- Get table window's parameter -----------------------------------------*/
#define rmGetTableHeight()          (rmSetTableHeight(-1))
#define rmGetTableAwidth()          (rmSetTableAwidth(-1))
#define rmGetTableDwidth()          (rmSetTableDwidth(-1))
#define rmGetPatDispType()          (rmSetPatDispType(RmPATTERN_UNDEF_TYPE))
#define rmGetWeightOn()             (rmSetWeightOn(RmNOT_BOOL))
#define rmGetDupNameCheck()         (rmSetDupNameCheck(RmNOT_BOOL))
#define rmGetDelRuleMessage()       (rmSetDelRuleMessage(RmNOT_BOOL))
#define rmGetDelDataMessage()       (rmSetDelDataMessage(RmNOT_BOOL))
#define rmGetSameGroupEditMode()    (rmSetSameGroupEditMode(RmNOT_BOOL))
#define rmGetNtblEditting()         (rmSetNtblEditting(RmNOT_BOOL))
#define rmGetNtblAffectData()       (rmSetNtblAffectData(RmNOT_BOOL))

/*----- Get file parameter ---------------------------------------------------*/
#define rmGetDataFilePath()         (rmSetDataFilePath((char *)NULL))
#define rmGetLearnParamFile()       (rmSetLearnParamFile((char *)NULL))
#define rmGetFSelectionBox()        (rmCreateFSelectionBox(-1, -1))

/*---- Get RNA color information ---------------------------------------------*/
#define rmGetDigColorOn()           (rmGetRNAColorPixel(0))
#define rmGetDigColorOff()          (rmGetRNAColorPixel(1))
#define rmGetAnaColorInput()        (rmGetRNAColorPixel(2))
#define rmGetAnaColorCenter()       (rmGetRNAColorPixel(3))

/*---- Get RNA file selection message ----------------------------------------*/
#define rmGetLoadRNAString()        (rmGetRNAFileMessage( 1))
#define rmGetSaveRNAString()        (rmGetRNAFileMessage(-1))
#define rmGetLoadSimString()        (rmGetRNAFileMessage( 2))
#define rmGetSaveSimString()        (rmGetRNAFileMessage(-2))
#define rmGetLoadIlaString()        (rmGetRNAFileMessage( 3))
#define rmGetSaveIlaString()        (rmGetRNAFileMessage(-3))

/*----- Get RNA table window's base size -------------------------------------*/
#define rmGetRNAApatWidth()         (rmSetRNAApatWidth(0))

/*----- Create selection box macro -------------------------------------------*/
#define rmCreateSelectSSwindow(w, x, y, b, pw) \
       (rmCreateNSelectSSwindow((w),(x),(y),(b),(RNUM)0,(RNUM)0,(pw)))
#define rmCreateSelectPTwindow(w, x, y, b, pw) \
       (rmCreateNSelectPTwindow((w),(x),(y),(b),(RNUM)0,(RNUM)0,(pw)))
#define rmCreateSelectPGwindow(w, x, y, b, pw) \
       (rmCreateNSelectPGwindow((w),(x),(y),(b),RmFALSE,(pw)))

/*----- Create name set macro ------------------------------------------------*/
#define rmCreateTextNameSet(w, nm, pw) \
           (rMCreateNameSet(w, nm, xmLabelGadgetClass,\
                                   xmTextWidgetClass, (Widget *)NULL, pw))
#define rmCreateLabelNameSet(w, nm, pw) \
           (rMCreateNameSet(w, nm, xmLabelGadgetClass,\
                                   xmLabelWidgetClass, (Widget *)NULL, pw))
#define rmCreateItemBtnNameSet(w, nm, pw) \
           (rMCreateNameSet(w, nm, xmPushButtonWidgetClass,\
                                   xmLabelWidgetClass, pw, (Widget *)NULL))

#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* not _MMI00FNC_H_ */
