/******************************************************************************
 *      Copyright      Advanced Intelligence Research, Inc.   1991-1992       *
 ******************************************************************************
 ******************************************************************************
 *
 *  File name  : rnaS0def.h
 *
 *  Note       : Beta-RNA Simulator (common)
 *
 * $Revision: 2.16 $
 * $Author: fujimaki $
 * $Date: 1999/11/05 03:03:48 $
 * $Locker:  $
 *
 *****************************************************************************/
#if !defined(RNAS0DEF_H)
#define RNAS0DEF_H

#include "rnaL0def.h"
#include "rnaS0usr.h"

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/*-------------------------- Simulator In/Out Data Info. --------------------*/
typedef struct {
    int    fNorm; /* Normalize Info. Level */
                  /* (0:none, 1:define by User, 2:define by Data) */
    double dMax;
    double dMin;
} RSIINFO;
/*-------------------------- Simulator System Mode --------------------------*/
typedef struct {
    int      fLearn;    /* Learn Mode (0:off, 1:normal, 2:add) */
    int      fPrint;    /* Print Mode */
    char    *sFileRNA;  /* Beta-RNA Data   File Name */
    char    *sFileIn;   /* Input Data      File Name */
    char    *sFilePara; /* Study Parameter File Name */
} RSMODE;
/*----------------------------- Strings Data --------------------------------*/
typedef struct {
    int    iSize; /* Number of Strings */
    char **psTop; /* Strings Pointer   */
} STRINGS;

/*--------------------------- Function Prototype ----------------------------*/
extern int  PROTOTYPE(rsGetString, (char *, STRINGS *));
extern Ferr PROTOTYPE(rsLoadInputFileHeadder, (STREAM *, RNUM *, RNUM *));
extern Ferr PROTOTYPE(rsLoadInDataName, (STREAM *, RID, RANA, double **));
extern Ferr PROTOTYPE(rsLoadOutDataName, (STREAM *, RNUM, RID, int, RSIINFO *));
extern Ferr PROTOTYPE(rsLoadSelectData, (STREAM *, RNUM, RBOOL *));
extern Ferr PROTOTYPE(rsGetInputMaxMin, (STREAM *, RANA, double *, RID));
extern Ferr PROTOTYPE(rsGetOutputMaxMin, (STREAM *, RNUM, RNUM, RSIINFO  *));
extern Ferr PROTOTYPE(rsGetPatternGroup, (RNUM, RNUM, RID *, RNUM));
extern Ferr PROTOTYPE(rsGetNormMax, (RID, RANA *));
extern Ferr PROTOTYPE(rsSetMode, (int, char **, RSMODE *));
extern Ferr PROTOTYPE(rsCreatePatTable, (RNUM, unsigned long, RLEXT *, RID *));
extern Ferr PROTOTYPE(rsSetPatMatchType, (RID, unsigned long));

#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif /* RNAS0DEF_H */
