/******************************************************************************
 *      Copyright      Advanced Intelligence Research, Inc.   1991-1992       *
 ******************************************************************************
 ******************************************************************************
 *
 *  File name  : rnaS2def.h
 *
 *  Note       : Beta-RNA Learnig Routine (Type 2)
 *
 * $Revision: 2.8 $
 * $Author: fujimaki $
 * $Date: 1999/11/05 03:03:48 $
 * $Locker:  $
 *
 *****************************************************************************/
#if !defined(RNAS2DEF_H)
#define RNAS2DEF_H

#include "rnaS0def.h"
#include "rnaS2usr.h"

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

typedef struct {
    double *pdCenter; /* Arrey[rnOut] */
    double *pdWeight; /* Arrey[rnOut] */
} RS2OPS;

typedef struct {
    RRANK    *prank;     /* Sort Result [rnActRes] */
    RID      *priNtbl;   /* Nomalize Table ID [rnOut] */
    RBOOL     rbOps;     /* Flag of Output PS Info. (RB_TRUE->Treated) */
    RNUM      rnOps;     /* Area Size of Output PS Info. */
    RS2OPS   *prs2ops;   /* Output PS Info. [rnOps] */
    RBOOL    *prbSelIn;  /* Input  Data Selection Flag [rnIn] */
    RBOOL    *prbSelOut; /* Output Data Selection Flag [rnOut] */
} RS2SYS;

#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif /* RNAS2DEF_H */
